# from ast import main
import random
from string import digits
import sys
import pygame
from pygame.locals import*
import time


# Global variables
PAUSE = False
FPS = 32
SCREENWIDTH = 1400
SCREENHEIGHT = 800
SCREEN = pygame.display.set_mode((SCREENWIDTH, SCREENHEIGHT))
GROUNDY = SCREENHEIGHT * 0.8
GAME_SPRITES = {}
GAME_SOUNDS = {}
PLAYER = 'Flappy_bird_game\\gallary\\sprites\\player_bird.png'
BACKGROUND = 'Flappy_bird_game\\gallary\\sprites\\Background-1.png'
PIPE = 'Flappy_bird_game\\gallary\\sprites\\pipe.jpg'

def welcomeScreen():
    playerx = int(SCREENWIDTH / 5)
    playery = int((SCREENHEIGHT - GAME_SPRITES['player'].get_height()) / 2)
    messagex = int((SCREENWIDTH - GAME_SPRITES['player'].get_width()) / 2)
    messagey = int(SCREENHEIGHT * 0.13)
    basex = 0

    while True:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                sys.exit()
            elif event.type == KEYDOWN and (event.key == K_SPACE or event.key == K_UP):
                return

            else:
                SCREEN.blit(GAME_SPRITES['message'], (-70,-10))
                SCREEN.blit(GAME_SPRITES['player'], (playerx, playery))
                # SCREEN.blit(GAME_SPRITES['message'], (messagex, messagey))
                SCREEN.blit(GAME_SPRITES['base'], (basex, GROUNDY))
                pygame.display.update()
                FPSCLOCK.tick(FPS)

def mainGame():
    score = 0
    playerx = int(SCREENWIDTH / 5)
    # playery = int(SCREENWIDTH/1.5)
    playery = int((SCREENHEIGHT - GAME_SPRITES['player'].get_height()) / 2)

    basex = 0

    newPipe1 = getRandomPipe()
    newPipe2 = getRandomPipe()

    upperPipes = [
        {'x' : SCREENWIDTH + 200, 'y' : newPipe1[0]['y']},
        {'x' : SCREENWIDTH + 200 + (SCREENWIDTH / 2), 'y' : newPipe2[0]['y']}
    ]

    lowerPipes = [
        {'x' : SCREENWIDTH + 200, 'y' : newPipe1[1]['y']},
        {'x': SCREENWIDTH + 200 + (SCREENWIDTH / 2), 'y' : newPipe2[1]['y']}
    ]

    pipeVelx = -4

    playerVelY = -9
    playerMaxVely = 10
    playerMinVely = -8
    playerAccY = 1

    playerFlapAccv = -8
    playerFlapped = False

    while True:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                sys.exit()
            if event.type == KEYDOWN and (event.key == K_SPACE or event.key == K_UP):
                if playery > 0:
                    playerVelY = playerFlapAccv
                    playerFlapped = True
                    GAME_SOUNDS['wing'].play()

        crashTest = isCollide(playerx, playery, upperPipes, lowerPipes)
        if crashTest:
            PAUSE = True
            return score

        # scores
        playerMidPos = playerx + GAME_SPRITES['player'].get_width() / 2
        for pipe in upperPipes:
            pipeMidPos = pipe['x'] + GAME_SPRITES['pipe'][0].get_width() / 2
            if pipeMidPos <= playerMidPos < pipeMidPos + 4:
                score += 1
                print(f"Your score is {score}")
                GAME_SOUNDS['point'].play()

        if playerVelY < playerMaxVely and not playerFlapped:
            playerVelY += playerAccY
        if playerFlapped:
            playerFlapped = False
        
        playerHeight = GAME_SPRITES['player'].get_height()
        playery = playery + min(playerVelY, GROUNDY- playery -playerHeight)

        # moving the pipes
        for upperPipe, lowerPipe in zip(upperPipes, lowerPipes):
            upperPipe['x'] += pipeVelx
            lowerPipe['x'] += pipeVelx 

        # Adding pipes
        if 0 < upperPipes[0]['x'] < 5:
            newpipe = getRandomPipe()
            upperPipes.append(newpipe[0])
            lowerPipes.append(newpipe[1])
    
        # removing the pipes
        if upperPipes[0]['x'] < - GAME_SPRITES['pipe'][0].get_width():
            upperPipes.pop(0)
            lowerPipes.pop(0)

        # blit
        SCREEN.blit(GAME_SPRITES['background'], (0, 0))
        for upperPipe, lowerPipe in zip(upperPipes, lowerPipes):
            SCREEN.blit(GAME_SPRITES['pipe'][0],(upperPipe['x'], upperPipe['y']))
            SCREEN.blit(GAME_SPRITES['pipe'][1],(lowerPipe['x'], lowerPipe['y']))
        
        SCREEN.blit(GAME_SPRITES['base'], (basex, GROUNDY))
        SCREEN.blit(GAME_SPRITES['player'], (playerx, playery))

        myDigits = [int(x) for x in list(str(score))]
        width = 0
        for digit in myDigits:
            width += GAME_SPRITES['numbers'][digit].get_width()
        Xoffset = (SCREENWIDTH - width)/ 2

        for digit in myDigits:
            SCREEN.blit(GAME_SPRITES['numbers'][digit], (Xoffset, SCREENWIDTH *0.12))
            Xoffset += GAME_SPRITES['numbers'][digit].get_width()

        pygame.display.update()
        FPSCLOCK.tick(FPS)


def isCollide(playerx, playery, upperPipes, lowerPipes) :
    if playery> GROUNDY - 151  or playery<0:
        GAME_SOUNDS['hit'].play()
        return True
    
    for pipe in upperPipes:
        pipeHeight = GAME_SPRITES['pipe'][0].get_height()
        if(playery < pipeHeight + pipe['y'] - 20 and abs(playerx - pipe['x']) < GAME_SPRITES['pipe'][0].get_width() - 110):
            GAME_SOUNDS['hit'].play()
            return True

    for pipe in lowerPipes:
        if (playery + GAME_SPRITES['player'].get_height() > pipe['y']) and abs(playerx - pipe['x']) < GAME_SPRITES['pipe'][0].get_width() - 110:
            GAME_SOUNDS['hit'].play()
            return True

    return False



def getRandomPipe():
    pipeHeight = GAME_SPRITES['pipe'][0].get_height()
    offset = SCREENHEIGHT/3
    y2 = offset + random.randrange(0, int(SCREENHEIGHT - GAME_SPRITES['base'].get_height() - 1.2*offset))
    pipeX = SCREENWIDTH + 10
    y1 = pipeHeight - y2 + offset
    pipe = [
        {'x':pipeX, 'y': -y1}, # upper pipe
        {'x': pipeX, 'y': y2}  # lower pipe
    ]
    return pipe



if __name__ == "__main__":
    pygame.init()
    FPSCLOCK = pygame.time.Clock()
    pygame.display.set_caption('The Flappy Bird Game')
    GAME_SPRITES['numbers'] = (

        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-0.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-1.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-2.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-3.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-4.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-5.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-6.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-7.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-8.png').convert_alpha(),
        pygame.image.load('Flappy_bird_game\\gallary\\sprites\\Untitled-9.png').convert_alpha()

    )

    # Game Sprites
    GAME_SPRITES['message'] = pygame.image.load('Flappy_bird_game\\gallary\\sprites\\initial.png').convert_alpha()
    GAME_SPRITES['base'] = pygame.image.load('Flappy_bird_game\\gallary\\sprites\\main_ground.png').convert_alpha()
    GAME_SPRITES['pipe'] = (pygame.transform.rotate(pygame.image.load(PIPE).convert_alpha(), 180), 
    pygame.image.load(PIPE).convert_alpha())
    GAME_SPRITES['background'] = pygame.image.load(BACKGROUND).convert()
    GAME_SPRITES['player'] = pygame.image.load(PLAYER).convert_alpha()


    # Game Sounds
    GAME_SOUNDS['die'] = pygame.mixer.Sound('Flappy_bird_game\\gallary\\audio\\die.mp3')
    GAME_SOUNDS['hit'] = pygame.mixer.Sound('Flappy_bird_game\\gallary\\audio\\hit.mp3')
    GAME_SOUNDS['point'] = pygame.mixer.Sound('Flappy_bird_game\\gallary\\audio\\point.mp3')
    GAME_SOUNDS['swoosh'] = pygame.mixer.Sound('Flappy_bird_game\\gallary\\audio\\swoosh.mp3')
    GAME_SOUNDS['wing'] = pygame.mixer.Sound('Flappy_bird_game\\gallary\\audio\\wing.mp3')

    def gameOverScreen(score):
        # SCREEN.fill(0,0,0)
        font = pygame.font.SysFont('arial', 60)
        line1 = font.render(f"Score : {score}", True, (0,0,0))
        SCREEN.blit(line1,(SCREENWIDTH/3 + 100,SCREENHEIGHT/2))
        if score!=0:
            line2 = font.render("To Play Again Press Enter", True, (255,0,0))
            SCREEN.blit(line2,(SCREENWIDTH/3 -20,SCREENHEIGHT/3 + 40))
        pygame.display.update()
        # pause = True
        time.sleep(1)



    while True:
        for event in pygame.event.get():
            if event.type == QUIT or (event.type == KEYDOWN and event.key == K_ESCAPE):
                pygame.quit()
                sys.exit()
            elif event.type == KEYDOWN and (event.key == K_RETURN):
                PAUSE = False
            else:
                font = pygame.font.SysFont('arial', 60)
                line1 = font.render("Press Enter to Start", True, (255,255,255))
                SCREEN.blit(line1,(SCREENWIDTH/3 +30,SCREENHEIGHT/3 + 40))
                pygame.display.update()
                # gameOverScreen(0)
                PAUSE = True
        if not PAUSE:
            welcomeScreen()
            score = mainGame()
            gameOverScreen(score)



